Decode Ways (#91 Leetcode)

 A message containing letters from A-Z can be encoded into numbers using the following mapping:

'A' -> "1"
'B' -> "2"
...
'Z' -> "26"

To decode an encoded message, all the digits must be grouped then mapped back into letters using the reverse of the mapping above (there may be multiple ways). For example, "11106" can be mapped into:

  • "AAJF" with the grouping (1 1 10 6)
  • "KJF" with the grouping (11 10 6)

Note that the grouping (1 11 06) is invalid because "06" cannot be mapped into 'F' since "6" is different from "06".

Given a string s containing only digits, return the number of ways to decode it.

The test cases are generated so that the answer fits in a 32-bit integer.

 

Example 1:

Input: s = "12"
Output: 2
Explanation: "12" could be decoded as "AB" (1 2) or "L" (12).

Example 2:

Input: s = "226"
Output: 3
Explanation: "226" could be decoded as "BZ" (2 26), "VF" (22 6), or "BBF" (2 2 6).

Example 3:

Input: s = "06"
Output: 0
Explanation: "06" cannot be mapped to "F" because of the leading zero ("6" is different from "06").

 

Constraints:

  • 1 <= s.length <= 100
  • s contains only digits and may contain leading zero(s).


The given string 226 can be decoded in three ways. Let's see how we can do that.

1. Iterate every element of the string from the start or end. 

If we start from the beginning, 2 is a single digit so far, so this can only be decoded in 1 way. 

So, store the number of ways as 1 in a dp array of 0th position.

dp[0] = 1;

2. Now, iterate to the 1st position. This can be considered as two digit along with previous digit. At this point, there are two ways to represent the digits 22. 

22                               

2    2                             

To store the value as 2 in dp[1] either one of the following conditions should satisfy. 

a) If the previous number(dp[0]) is 1 and current element is 0-9, then dp[1] will be 2 

b) If the previous number(dp[0]) is 2 and current element is 0-6, then dp[1] will be 2 

3. Now, iterate to the 2nd position. Repeat step 2. 

22   6                            

2     2     6                     

2     26                          

Since the constraint is string will have a minimum length of 1. 


If It is a single digit, it can't be 0. 

Maximum of two digits are allowed. For a char to consider as a two digit, it should have size greater than 2 (0th index + 1st index). 

Always firstly store the next dp's value and then check if it is valid two digit and add dp[i+2]

class Solution {
public:
    int numDecodings(string s) {
       int n = s.size(); 
       vector<int> dp(n+1, 0);
       dp[n] = 1;
       for (int i = n-1; i >=0; --i) {
           if (s[i] != '0') {
               dp[i] = dp[i+1];
           } 
           if (i+1 < s.size() && 
               (s[i] == '1' || s[i] == '2' && s[i+1] <= '6')) {
               dp[i] += dp[i+2];         
           }
       }
       return dp[0];
    }
};



Comments